// const util = require('@/static/utils/util.js');
// const config = require('@/static/config.js');
import wallType from '@/static/wallData.js';
// import requestConfig from '@/services/requestConfig.js';
import * as THREE from 'three';
import TWEEN from 'three/addons/libs/tween.module.js';
export default {
	data() {
		return {
			// gltfUrl:"https://dm.static.elab-plus.com/3d/model/230519/floor01.glb",//模型地址
			// gltfName:"地板",	//模型名称
			// gltfWidth:10,	//模型宽度 10米
			// gltfHeight:10,	//模型高度 10米
		}
	},
	watch: {},
	methods: {
		// modelItem 变化后的
		// wallObj 变化前的-一面墙下的某一段墙体
		drawModel(modelItem, spaceObj, wallObj, isAnimate = false) {
			let that = this;
			//无变化则不需要启动动画
			if (modelItem.wallPositionX == wallObj.wallPositionX &&
				modelItem.wallPositionY == wallObj.wallPositionY &&
				modelItem.wallScaleX == wallObj.wallScaleX &&
				modelItem.wallScaleY == wallObj.wallScaleY) {
				return false;
			}
			let tx = wallObj.wallPositionX;
			let tz = wallObj.wallPositionY;
			let scaleX = wallObj.wallScaleX;
			let wallWidth = wallObj.wallWidth; //初始的墙体宽度-单位m
			//最终形变值
			let toPx = modelItem.wallPositionX;
			let toPz = modelItem.wallPositionY;
			let toScaleX = modelItem.wallScaleX;


			if (modelItem.wallType != 0 && parseFloat(modelItem.wallWidth) == 0) {
				toScaleX = 0
			}

			if (isAnimate) { //需要动画
				// console.log("墙体动画1----", tx, tz, scaleX,toPx, toPz, toScaleX,);
				// console.log("墙体动画2----", scaleX, toScaleX, wallObj.wallScaleX, wallObj);
				//初始形变值
				let spaceInitMatrix = []; //记录下动画创建时的初始变换矩阵
				wallObj.instancedMeshIndexList.forEach(item => {
					let _index = item.instancedMeshIndex;
					let instancedMesh = this.instancedMeshList[_index]; //获取网格实例
					let startMatrix = new THREE.Matrix4(); //定义一个四维矩阵
					instancedMesh.getMatrixAt(item.instancedAtIndex, startMatrix); //获取当前几何体的四维矩阵到stratMatrix里面
					spaceInitMatrix.push({
						index: _index,
						matrix: startMatrix.clone(),
					})
				});
				var tween = new TWEEN.Tween({
						x: tx,
						z: tz,
						sx: scaleX,
					})
					.to({
						x: toPx,
						z: toPz,
						sx: toScaleX,
					}, 2000)
					.easing(TWEEN.Easing.Quadratic.InOut)
					.onUpdate((object) => {
						wallObj.instancedMeshIndexList.forEach(item => {
							let _index = item.instancedMeshIndex;
							let instancedMesh = this.instancedMeshList[_index]; //获取网格实例
							let tmp = spaceInitMatrix.find(it => it.index == _index);
							let stratMatrix = tmp.matrix.clone(); //获取初始变换矩阵
							// // 计算变化后的位置：位移后的位置 是 当前几何体的位置参数 加上 模型移动后的位置偏移量
							let moveX = object.x - tx;
							let moveZ = object.z - tz;
							let scaleMatrix = new THREE.Matrix4(); //定义一个缩放变化矩阵
							let panMatrix = new THREE.Matrix4(); //定义一个平移变化矩阵
							scaleMatrix.makeScale(object.sx / scaleX, 1, 1); //获得缩放变化矩阵
							panMatrix.makeTranslation(moveX, 0, moveZ); //获得平移变化矩阵
							stratMatrix.multiply(scaleMatrix).premultiply(panMatrix); //通过矩阵计算获得最终的形变矩阵
							instancedMesh.instanceMatrix.needsUpdate = true; //更新之前，必须开启开关
							instancedMesh.setMatrixAt(item.instancedAtIndex, stratMatrix); //更新几何体的世界矩阵
							// console.warn("***drawModel-isAnimate0***",JSON.stringify(position),JSON.stringify(scale),wallObj.name,modelItem,wallObj);
						})
					}).onComplete(() => {
						this.tweenCameraAnmaChange(false);
						let gltfWall = this.gltfWalls.find(gltfWall => gltfWall.uniId == wallObj.uniId); //判断是否已经添加过
						if (gltfWall) {
							gltfWall.wallPositionX = modelItem.wallPositionX;
							gltfWall.wallPositionY = modelItem.wallPositionY;
							gltfWall.wallScaleX = modelItem.wallScaleX;
							gltfWall.wallScaleY = modelItem.wallScaleY;
							gltfWall.wallRotateY = modelItem.wallRotateY;
							gltfWall.wallWidth = modelItem.wallWidth;
						} else {
							console.warn("***changeSpacesAnim-over-wall***", wallObj.uniId, wallObj)
						}
						// console.warn("***changeSpacesAnim-over-wall***", modelItem)
					});
				// 开始动画
				tween.start();
				this.tweenCameraAnmaChange(true)
			} else {
				// console.log("墙体变化", modelItem, wallObj, wallObj.wallWidth);
				wallObj.instancedMeshIndexList.forEach(item => {
					let _index = item.instancedMeshIndex;
					let instancedMesh = this.instancedMeshList[_index]; //获取网格实例
					// let tmp = spaceInitMatrix.find(it=>it.index==_index);
					// let stratMatrix = tmp.matrix.clone();	//获取初始变换矩阵
					let stratMatrix = new THREE.Matrix4(); //定义一个四维矩阵
					instancedMesh.getMatrixAt(item.instancedAtIndex, stratMatrix); //获取当前几何体的四维矩阵到stratMatrix里面
					// // 计算变化后的位置：位移后的位置 是 当前几何体的位置参数 加上 模型移动后的位置偏移量
					let moveX = toPx - tx;
					let moveZ = toPz - tz;
					let scaleMatrix = new THREE.Matrix4(); //定义一个缩放变化矩阵
					let panMatrix = new THREE.Matrix4(); //定义一个平移变化矩阵

					scaleMatrix.makeScale(toScaleX / scaleX, 1, 1); //获得缩放变化矩阵
					panMatrix.makeTranslation(moveX, 0, moveZ); //获得平移变化矩阵
					stratMatrix.multiply(scaleMatrix).premultiply(panMatrix); //通过矩阵计算获得最终的形变矩阵
					instancedMesh.instanceMatrix.needsUpdate = true; //更新之前，必须开启开关
					instancedMesh.setMatrixAt(item.instancedAtIndex, stratMatrix); //更新几何体的世界矩阵
					// console.warn("***drawModel-isAnimate0***",JSON.stringify(position),JSON.stringify(scale),wallObj.name,modelItem,wallObj);
				})
				let gltfWall = this.gltfWalls.find(gltfWall => gltfWall.uniId == wallObj.uniId); //判断是否已经添加过
				gltfWall.wallPositionX = modelItem.wallPositionX;
				gltfWall.wallPositionY = modelItem.wallPositionY;
				gltfWall.wallScaleX = modelItem.wallScaleX;
				gltfWall.wallScaleY = modelItem.wallScaleY;
				gltfWall.wallRotateY = modelItem.wallRotateY;
				gltfWall.wallWidth = modelItem.wallWidth;
				gltfWall.lastWallType = 50;
			}

		},
		//预处理需要加载墙体模型的数据-减少模型请求数
		preWallData(wallArr) {
			let realWallArr = [];
			wallArr && wallArr.forEach((item, index) => {
				item.uniId = Date.now() + index; //唯一标识
				//获取墙体对应的gltb模型的相关信息
				let modelTypeItem = wallType.find(it => it.type == item.wallModelData
					.wallType) //wallType[item.wallModelData.wallType];
				// console.log("取墙体对应的gltb模型的相关信息", modelTypeItem, item);
				let object = realWallArr.find(it => it.index == item.wallModelData.wallType);
				//列表中还没有这个数据
				if (!object) {
					let it = {
						url: modelTypeItem.url,
						list: [item],
						name: modelTypeItem.name,
						index: item.wallModelData.wallType, //在模型当中的类型编码
					}
					realWallArr.push(it)
				} else {
					object.list.push(item);
				}
			});
			return realWallArr;
		},
		// 加载墙体模型
		loadWallModels(realData, wallList, arrLength, resolve) {
			var that = this;
			if (!realData.url) {
				console.warn("***模型wallType不存在***", realData);
				return false;
			}
			that.loader.load(realData.url, (gltf) => {
				that.progress = parseInt(100 / arrLength) + that.progress;
				if (that.progress > 100) {
					that.progress = 100;
				}
				this.$store.state.loadingMsg = "加载中..." + that.progress + '%';
				// console.log("模型加载成功",that.progress,realData,gltf);
				// 第一个方案：递归获取模型-并一一实例化，减少渲染次数，提高性能；因为实例化了几何体复用了geometry 和 material
				// DrawCall和内存都很低
				gltf.scene.traverse((child) => {
					if (child.isMesh && child.visible) {
						let instancedMesh = new THREE.InstancedMesh(child.geometry.clone(), child
							.material.clone(), realData.list.length);
						this.instancedMeshList.push(instancedMesh);
						//realData 该模型被重复使用时的每一次的形变参数等
						realData.list && realData.list.forEach((it, i) => {
							let modelItem = JSON.parse(JSON.stringify(it.wallModelData));
							gltf.scene.position.set(modelItem.wallPositionX, 0, modelItem
								.wallPositionY);
							gltf.scene.scale.set(modelItem.wallScaleX, 1, modelItem.wallScaleY);
							gltf.scene.rotation.y = modelItem.wallRotateY;

							gltf.scene.updateMatrixWorld(); //更新世界坐标-这样，子模型也同步更新了
							instancedMesh.setMatrixAt(i, child.matrixWorld);
							instancedMesh.instanceMatrix.needsUpdate = true;
							// instancedMesh.setColorAt(i, child.material.color);
							// instancedMesh.instanceColor.needsUpdate = true;
							// console.log("***matrixWorld***",child.matrixWorld);
							let gltfWall = that.gltfWalls.find(gltfWall => gltfWall.uniId == it
								.uniId); //判断是否已经添加过
							if (!gltfWall) {
								let md = {
									uniId: it.uniId, //模型实例的唯一标识
									spaceId: it.spaceId,
									instancedMeshIndexList: [ //标识网格实例数组的序号 以及 当前几何体 在网格实例的序号
										{
											instancedMeshIndex: this.instancedMeshList
												.length - 1,
											instancedAtIndex: i
										},
									],
									wallPositionX: modelItem.wallPositionX,
									wallPositionY: modelItem.wallPositionY,
									wallScaleX: modelItem.wallScaleX,
									wallScaleY: modelItem.wallScaleY,
									wallRotateY: modelItem.wallRotateY,
									wallWidth: modelItem.wallWidth,
									wallModelData: modelItem,
									wallModelInitData: modelItem, // 保留初始化墙体数据，方便空间变形计算缩放比例 
									wallDirection: it.wallDirection,
									willCurWallType: -1, // 即将成为当前模型，作用于动画加载完替换
									lastWallType: -1 // 上一次墙体模型
								};

								that.gltfWalls.push(md);
							} else {
								gltfWall.instancedMeshIndexList.push({
									instancedMeshIndex: this.instancedMeshList.length -
										1,
									instancedAtIndex: i
								})
							}
						})
						instancedMesh.userType = "mesh";
						// instancedMesh.receiveShadow = true;//材质是否接收阴影
						that.scene.add(instancedMesh);
					}
				});
				resolve();
			});
		},
		//计算墙体对应位置和形变参数-提前计算
		computeWallHandleOld(spaceObj, wallObj) {
			// let cube = wallObj.obj;
			let list = wallObj.wallData; //墙体列表
			let scale = 100;
			let spaceWallInfo = {
				wallN: false,
				wallS: false,
				wallW: false,
				wallE: false
			};
			spaceObj.spaceWallInfo = spaceWallInfo;
			list.forEach((item) => { //空间下的四面墙壁
				let lastWallPosition = 0;
				let wallDirection = item.wallDirection;
				item.wallModelData.forEach((modelItem, index) => { //每个墙壁下的位置计算
					// 默认空间中心点
					let wallPositionX = spaceObj.centerX / 100;
					let wallPositionY = spaceObj.centerY / 100;
					let wallRotateY = 0;

					let wallHeight = 10; //item.wallHeight // 墙体厚度模型10cm
					if (wallDirection == "N") {
						wallPositionY = wallPositionY * -1 - spaceObj.spaceHeight / 2 / scale;
						let wallHeight2 = wallHeight / 2 / scale;
						wallPositionY = wallPositionY + wallHeight2;
						spaceWallInfo.wallN = true;
					} else if (wallDirection == "S") {
						wallPositionY = wallPositionY * -1 + spaceObj.spaceHeight / 2 / scale;
						let wallHeight2 = wallHeight / 2 / scale;
						wallPositionY = wallPositionY - wallHeight2;
						spaceWallInfo.wallS = true;
					}
					if (wallDirection == "E") {
						// console.log("模型参数", wallPositionX, spaceObj.spaceWidth)
						wallPositionY = wallPositionY * -1;
						wallPositionX = wallPositionX + spaceObj.spaceWidth / 2 / scale;
						let wallHeight2 = wallHeight / 2 / scale;
						wallPositionX = wallPositionX - wallHeight2; // 减去墙体本身的厚度
						wallRotateY = Math.PI / 2; // 东西墙 模型旋转90度
						spaceWallInfo.wallE = true;
					} else if (wallDirection == "W") {
						wallPositionY = wallPositionY * -1;
						wallPositionX = wallPositionX - spaceObj.spaceWidth / 2 / scale;
						let wallHeight2 = wallHeight / 2 / scale;
						wallPositionX = wallPositionX + wallHeight2; // 减去墙体本身的厚度
						wallRotateY = Math.PI / 2; // 东西墙 模型旋转90度
						spaceWallInfo.wallW = true;
					}
					let wallScaleX = 1;
					let wallScaleY = 1;
					let modelWidth = 10;
					if (modelItem.wallType == '7') {
						modelWidth = 150
					} else if (modelItem.wallType == '21') {
						modelWidth = 100
					} else if (modelItem.wallType == '22') {
						modelWidth = 200
					} else if (modelItem.wallType == '23') {
						modelWidth = 300
					} else if (modelItem.wallType == '24') {
						modelWidth = 400
					} else if (modelItem.wallType == '25') {
						modelWidth = 500
					} else if (modelItem.wallType == '26') {
						modelWidth = 600
					}
					let tmdWidth = modelItem.wallWidth; //记录
					// console.log("XXXXXXXXXXXXXXXX", modelWidth, spaceObj)
					// 计算墙体的 X Y W H
					//说明该面墙壁只使用了一个模型-独占形式
					if (modelItem.isStepAsideTopRight == 'true' && modelItem.isStepAsideBottomLeft ==
						'true') {
						if (wallDirection == "S" || wallDirection == "N") { //南北
							wallScaleX = spaceObj.spaceWidth / modelWidth;
						} else { //东西
							wallScaleX = spaceObj.spaceHeight / modelWidth;
						}
						if ((parseInt(modelItem.wallType) >= 21 && parseInt(modelItem.wallType) <=
							26) || parseInt(modelItem.wallType) == 7) {} else {
							modelItem.wallWidth = wallScaleX * modelWidth; // 解决模型行拉伸定位问题， 先注释
						}

					} else { //墙面是多端墙体组合而成的
						if (modelItem.isFixedWidth == 'true') { //该墙体锁定宽度-即不可缩放
							let wallWidth = modelItem.wallWidth; // 墙体宽度
							// console.log("模型的尺寸",wallWidth, spaceObj.spaceWidth, spaceObj.centerX)
							//起始墙体-南北从左侧算，东西则从上侧计算
							if (modelItem.isStepAsideBottomLeft == 'true' || modelItem
								.isStepAsideTopRight == 'true') {
								if (wallDirection == "S" || wallDirection == "N") { //南北
									wallPositionX = spaceObj.centerX - (spaceObj.spaceWidth -
										wallWidth) / 2;
									wallPositionX = wallPositionX / scale; // 转换成m
								} else {
									wallPositionY = -spaceObj.centerY - (spaceObj.spaceHeight -
										wallWidth) / 2;
									wallPositionY = wallPositionY / scale; // 转换成m
								}
							} else {
								if (wallDirection == "S" || wallDirection == "N") { //南北
									wallPositionX = lastWallPosition + (wallWidth / 2 / scale);
								} else {
									wallPositionY = lastWallPosition + (wallWidth / 2 / scale);
								}
							}
							// console.log("模型的尺寸",wallWidth, wallPositionX)
							if (modelItem.wallType == 0) {
								wallScaleX = modelItem.wallWidth / wallHeight;
							}
							//计算当前墙体占据的整面墙体的大小-方便下一段墙体的计算
							if (wallDirection == "S" || wallDirection == "N") { //南北
								lastWallPosition = wallPositionX + wallWidth / 2 / scale;
							} else {
								lastWallPosition = wallPositionY + wallWidth / 2 / scale;
							}

						} else { //可变墙体-UE编辑器通常把它放到最后一段墙体
							let wallWidth = 0;
							//墙体的宽度是计算得出的
							if (wallDirection == "S" || wallDirection == "N") { //南北
								wallWidth = (spaceObj.centerX + spaceObj.spaceWidth / 2) -
									lastWallPosition * scale; // 墙体宽度
								// console.log("最后一个模型",spaceObj.centerX, spaceObj.spaceWidth / 2, lastWallPosition)
							} else {
								wallWidth = (-spaceObj.centerY + spaceObj.spaceHeight / 2) -
									lastWallPosition * scale; // 墙体宽度
							}
							wallWidth = wallWidth / scale; // cm转换成m
							if (modelItem.wallType == 0) {
								wallScaleX = wallWidth * wallHeight;
								if (wallDirection == "S" || wallDirection == "N") { //南北
									wallPositionX = lastWallPosition + wallWidth / 2;
								} else {
									wallPositionY = lastWallPosition + wallWidth / 2;
								}
							}
							modelItem.wallWidth = wallWidth * scale; //确保单位一致
						}
					}
					//计算得出墙体相应的位置和变形属性
					modelItem.wallPositionX = wallPositionX;
					modelItem.wallPositionY = wallPositionY;
					modelItem.wallScaleX = wallScaleX;
					modelItem.wallScaleY = wallScaleY;
					modelItem.wallRotateY = wallRotateY;
					// console.log("XXXXXXXXXXXXXXXX", modelWidth, modelItem)
					//新版下，符合条件的不止一个了，因为新版下是以模型里面的几何体为单元，个数较多
					this.gltfWalls.forEach(gltfItem => {
						if (gltfItem.spaceId == spaceObj.spaceId &&
							wallDirection == gltfItem.wallDirection &&
							modelItem.id == gltfItem.wallModelData.id) {
							gltfItem.wallModelData = JSON.parse(JSON.stringify(modelItem));
						}
					})
				})
				spaceObj.spaceWallInfo = spaceWallInfo;
			})
		},
		// 新计算墙体逻辑
		computeWallHandle(oldSpaceObj, spaceObj, wallObj, moveOut, direction) {
			var that = this;
			let list = wallObj.wallData; //墙体列表
			let scale = 100;
			console.log("墙体数据1", direction, list, moveOut, that.gltfWalls, wallObj);
			console.log("旧空间+++", oldSpaceObj.spaceId, oldSpaceObj.centerX, oldSpaceObj.centerY, oldSpaceObj.spaceWidth,
				oldSpaceObj.spaceHeight);
			console.log("新空间+++", spaceObj.spaceId, spaceObj.centerX, spaceObj.centerY, spaceObj.spaceWidth, spaceObj
				.spaceHeight);

			list.forEach((item) => { //空间下的四面墙壁
				let lastWallPosition = 0;
				let wallDirection = item.wallDirection;

				let spaceSize = 0
				let oldSpaceSize = 0
				let minWallWidth = 10; // 实墙最小宽度

				let wallCount = item.wallModelData.length;
				let isCurWall = true;
				let isCreateNewWall = false;
				let newWallType = null;

				if (wallDirection == "N" || wallDirection == "S") {
					spaceSize = spaceObj.spaceWidth;
					oldSpaceSize = oldSpaceObj.spaceWidth;
				} else {
					spaceSize = spaceObj.spaceHeight;
					oldSpaceSize = oldSpaceObj.spaceHeight;
				}

				let isComputeWall = true;

				if ((direction == "S" || direction == "N") && (wallDirection == "S" || wallDirection == "N")) {
					isComputeWall = false;
				}
				if ((direction == "E" || direction == "W") && (wallDirection == "E" || wallDirection == "W")) {
					isComputeWall = false;
				}

				if (wallCount > 2 && isComputeWall) { // 墙体个数，判断是否有墙体模型

					const modelItem0 = item.wallModelData[0]; // 固定尺寸实体墙
					const modelItem1 = item.wallModelData[1]; // 取出模型的宽度
					const modelItem2 = item.wallModelData[2]; // 伸缩实体墙

					const leftWallChangeValue = spaceSize - minWallWidth - parseFloat(modelItem1.wallWidth) -
						parseFloat(modelItem0.wallWidth);


					console.log("当前模型的类型信息", modelItem1, leftWallChangeValue)
					if (moveOut) { // 放大
						// 1.判断是否是从无到有
						// 是
						// 2 先还原窗户，找到最合适的窗户
						// 3 最后还原第一面实体墙
						// 否
						// 4 找到最合适的窗户
						// 5 最后还原第一面实体墙
						const curWallType = wallType.find(it => it.type == modelItem1.wallType)
						const wallTypeGroups = wallType.filter(it => it.group == curWallType.group)
						const wallWidth = spaceSize - 2 * minWallWidth;
						if (wallWidth > curWallType.width) {
							newWallType = curWallType;
						}
						for (let index = 0; index < wallTypeGroups.length; index++) {
							const element = wallTypeGroups[index];
							if (!newWallType) {
								if (element.width <= wallWidth) {
									newWallType = element;
								}
							} else {
								if (element.width <= wallWidth && newWallType.width <= element.width) {
									newWallType = element;
								}
							}
							console.log("寻找最大的窗户", index, wallWidth, newWallType, element.width)
						}

						item.wallModelData[1].wallWidth = newWallType.width;
						if (newWallType != curWallType) { // 新模型
							item.wallModelData[1].willCurWallType = newWallType.type;
							item.wallModelData[1].lastWallType = curWallType.type;

							isCreateNewWall = true;
						} else {
							console.log("还原老模型")
						}

						// 初始化模型的尺寸
						const initWallModel = this.gltfWalls.find(it => {
							return it.spaceId == spaceObj.spaceId && it.wallDirection ==
								wallDirection && it.wallModelData.wallType == 0 && it.wallModelData
								.isFixedWidth == 'true'
						})
						const item0Width = Math.min((spaceSize - newWallType.width - minWallWidth),
							initWallModel.wallModelInitData.wallWidth);
						item.wallModelData[0].wallWidth = item0Width
						console.log("还原第一面墙的宽度", item0Width, spaceSize, newWallType.width, minWallWidth);
					} else { // 缩小
						// 初始化模型的尺寸
						const initWallModel = this.gltfWalls.find(it => {
							return it.spaceId == spaceObj.spaceId && it.wallDirection ==
								wallDirection && it.wallModelData.wallType == 0 && it.wallModelData
								.isFixedWidth == 'true'
						})
						const firstWallW = initWallModel.wallModelInitData.wallWidth;
						// 计算最右边墙体尺寸
						const modelItem2W = oldSpaceSize - parseFloat(firstWallW) - parseFloat(modelItem1
							.wallWidth);
						if (modelItem2W > 10) {

						}

						// 计算最右边墙体的比例
						const modelItem0Scale = firstWallW / oldSpaceSize;
						const modelItem2Scale = modelItem2W / oldSpaceSize;

						const modelItem0NewW = modelItem0Scale * spaceSize;
						const modelItem2NewW = modelItem2Scale * spaceSize;

						console.log("墙体模型比例数据", oldSpaceSize, spaceSize, initWallModel.wallModelInitData
							.wallWidth, modelItem0Scale, modelItem0NewW, modelItem2NewW);

						if (leftWallChangeValue < 0) {
							const newWallWidth = Math.max(parseFloat(modelItem0.wallWidth) +
								leftWallChangeValue, minWallWidth);
							item.wallModelData[0].wallWidth = Math.floor(newWallWidth)
							console.log("缩放左边实体墙", spaceObj.spaceId, newWallWidth, leftWallChangeValue);
							if (modelItem1.wallWidth > spaceSize - 2 * minWallWidth) {
								console.log("无法放置墙体模型", newWallWidth, leftWallChangeValue);
								// 寻找合适的模型
								const curWallType = wallType.find(it => it.type == modelItem1.wallType)
								// 可显示的最大模型
								if (curWallType) {
									const wallTypeGroups = wallType.filter(it => it.group == curWallType.group)
									const wallWidth = spaceSize - 2 * minWallWidth;
									for (let index = 0; index < wallTypeGroups.length; index++) {
										const element = wallTypeGroups[index];

										if (!newWallType) {
											if (element.width <= wallWidth && element.width <= curWallType
												.width) {
												newWallType = element;
											}
										} else {
											if (newWallType.width <= element.width && element.width <=
												wallWidth && element.width <= curWallType.width) {
												newWallType = element;
											}
										}

									}
									console.log("是否需要替换墙体模型", spaceObj.spaceHeight, wallDirection, newWallType,
										curWallType.type)

									if (newWallType) {
										if (curWallType.type != newWallType.type) {
											console.log("最合适的墙体模型", spaceObj.spaceId, wallWidth, direction,
												wallDirection)
											item.wallModelData[1].wallWidth = newWallType.width;
											item.wallModelData[1].willCurWallType = newWallType.type;
											item.wallModelData[1].lastWallType = curWallType.type;
											item.wallModelData[0].wallWidth = Math.floor((spaceSize -
												newWallType.width) / 2)
											isCurWall = false;

											// 添加新模型
											const index = this.gltfWalls.findIndex(it => {
												// console.log("最合适的墙体模型", it.spaceId, spaceObj.spaceId, it.wallDirection, wallDirection, newWallType.wallType, it.wallModelData.wallType)
												return it.spaceId == spaceObj.spaceId && it
													.wallDirection == wallDirection && newWallType
													.wallType == it.wallModelData.wallType
											})
											if (index != -1) {
												console.log("不需要加载新模型", spaceObj.spaceId, direction,
													wallDirection)
												isCreateNewWall = false;
											} else {
												console.log("需要加载新模型", index)
												isCreateNewWall = true;
											}
										} else {
											console.log("保持当前模型的尺寸", spaceObj.spaceHeight, direction,
												wallDirection)
											item.wallModelData[1].wallWidth = 0.0001;
											item.wallModelData[1].willCurWallType = -1;
										}

									} else {
										console.log("没有合适的模型替换", spaceObj.spaceId, direction, wallDirection)
										item.wallModelData[1].wallWidth = 0.0001;
										item.wallModelData[1].willCurWallType = -1;
									}
								}
							} else {
								console.log("不需要添加");
							}
						} else {
							item.wallModelData[0].wallWidth = Math.floor(modelItem0NewW)
							console.log("等比缩放");
						}
					}

				} else {
					console.log("没有缩放墙体")
				}
				// 判断是否有下一级
				if ((direction == "S" && wallDirection != "S") || (direction == "W" && wallDirection !=
					"W")) { // 处理不同面的墙体，
					item.wallModelData.forEach((modelItem, index) => { //每个墙壁下的位置计算
						// 默认空间中心点
						let wallPositionX = spaceObj.centerX / 100;
						let wallPositionY = spaceObj.centerY / 100;
						let wallRotateY = 0;

						let wallHeight = 10; //item.wallHeight // 墙体厚度模型10cm
						if (wallDirection == "N") {
							wallPositionY = wallPositionY * -1 - spaceObj.spaceHeight / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionY = wallPositionY + wallHeight2;

						} else if (wallDirection == "S") {
							wallPositionY = wallPositionY * -1 + spaceObj.spaceHeight / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionY = wallPositionY - wallHeight2;
						}
						if (wallDirection == "E") {
							// console.log("模型参数", wallPositionX, spaceObj.spaceWidth)
							wallPositionY = wallPositionY * -1;
							wallPositionX = wallPositionX + spaceObj.spaceWidth / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionX = wallPositionX - wallHeight2; // 减去墙体本身的厚度
							wallRotateY = Math.PI / 2; // 东西墙 模型旋转90度
						} else if (wallDirection == "W") {
							wallPositionY = wallPositionY * -1;
							wallPositionX = wallPositionX - spaceObj.spaceWidth / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionX = wallPositionX + wallHeight2; // 减去墙体本身的厚度
							wallRotateY = Math.PI / 2; // 东西墙 模型旋转90度
						}
						let wallScaleX = modelItem.wallScaleX;
						let wallScaleY = 1;
						let modelWidth = 10;
						if (modelItem.wallType == '7') {
							modelWidth = 150
						} else if (modelItem.wallType == '21') {
							modelWidth = 100
						} else if (modelItem.wallType == '22') {
							modelWidth = 200
						} else if (modelItem.wallType == '23') {
							modelWidth = 300
						} else if (modelItem.wallType == '24') {
							modelWidth = 400
						} else if (modelItem.wallType == '25') {
							modelWidth = 500
						} else if (modelItem.wallType == '26') {
							modelWidth = 600
						}
						let tmdWidth = modelItem.wallWidth; //记录
						// console.log("XXXXXXXXXXXXXXXX", modelWidth, spaceObj)
						let wallWidth = 0; // 墙体宽度
						// 计算墙体的 X Y W H
						//说明该面墙壁只使用了一个模型-独占形式
						if (modelItem.isStepAsideTopRight == 'true' && modelItem
							.isStepAsideBottomLeft == 'true') {
							if (wallDirection == "S" || wallDirection == "N") { //南北
								wallScaleX = spaceObj.spaceWidth / modelWidth;
							} else { //东西
								wallScaleX = spaceObj.spaceHeight / modelWidth;
							}
							if ((parseInt(modelItem.wallType) >= 21 && parseInt(modelItem.wallType) <=
									26) || parseInt(modelItem.wallType) == 7) {} else {
								modelItem.wallWidth = wallScaleX * modelWidth; // 解决模型行拉伸定位问题， 先注释
							}

						} else { //墙面是多端墙体组合而成的
							if (modelItem.isFixedWidth == 'true') { //该墙体锁定宽度-即不可缩放
								wallWidth = modelItem.wallWidth; // 墙体宽度
								// console.log("模型的尺寸",wallWidth, spaceObj.spaceWidth, spaceObj.centerX)
								//起始墙体-南北从左侧算，东西则从上侧计算
								if (modelItem.isStepAsideBottomLeft == 'true' || modelItem
									.isStepAsideTopRight == 'true') {
									if (wallDirection == "S" || wallDirection == "N") { //南北
										wallPositionX = spaceObj.centerX - (spaceObj.spaceWidth -
											wallWidth) / 2;
										wallPositionX = wallPositionX / scale; // 转换成m
									} else {
										wallPositionY = -spaceObj.centerY - (spaceObj.spaceHeight -
											wallWidth) / 2;
										wallPositionY = wallPositionY / scale; // 转换成m
									}
								} else {
									if (wallDirection == "S" || wallDirection == "N") { //南北
										wallPositionX = lastWallPosition + (wallWidth / 2 / scale);
									} else {
										wallPositionY = lastWallPosition + (wallWidth / 2 / scale);
									}
								}
								// console.log("模型的尺寸",wallWidth, wallPositionX)
								if (modelItem.wallType == 0) {
									wallScaleX = modelItem.wallWidth / wallHeight;
								} else {
									console.log("墙体模型的缩放", spaceObj.spaceId, wallDirection, modelItem);
									// if(!moveOut){
									const curWallType = wallType.find(it => it.type == modelItem
										.wallType)
									wallScaleX = modelItem.wallWidth / curWallType.width;

									console.log("墙体模型的缩小", modelItem, direction, wallDirection);
									// }else{
									// 	console.log("墙体模型的放大", wallScaleX);
									// }

								}
								//计算当前墙体占据的整面墙体的大小-方便下一段墙体的计算
								if (wallDirection == "S" || wallDirection == "N") { //南北
									lastWallPosition = wallPositionX + wallWidth / 2 / scale;
								} else {
									lastWallPosition = wallPositionY + wallWidth / 2 / scale;
								}
								// wallPositionY = 1;
							} else { //可变墙体-UE编辑器通常把它放到最后一段墙体
								wallWidth = 0;
								//墙体的宽度是计算得出的
								if (wallDirection == "S" || wallDirection == "N") { //南北
									wallWidth = (spaceObj.centerX + spaceObj.spaceWidth / 2) -
										lastWallPosition * scale; // 墙体宽度
									// console.log("最后一个模型",spaceObj.centerX, spaceObj.spaceWidth / 2, lastWallPosition)
								} else {
									wallWidth = (-spaceObj.centerY + spaceObj.spaceHeight / 2) -
										lastWallPosition * scale; // 墙体宽度
								}
								wallWidth = wallWidth / scale; // cm转换成m
								if (modelItem.wallType == 0) {
									wallScaleX = wallWidth * wallHeight;
									if (wallDirection == "S" || wallDirection == "N") { //南北
										wallPositionX = lastWallPosition + wallWidth / 2;
									} else {
										wallPositionY = lastWallPosition + wallWidth / 2;
									}
								}
								modelItem.wallWidth = wallWidth * scale; //确保单位一致
								// wallPositionY = 1;
							}
						}


						console.log("移动墙体模型-空间信息", spaceObj.spaceWidth, spaceObj.centerX, spaceObj
							.centerY, spaceObj)
						console.log("移动墙体模型-墙体信息", spaceObj.spaceId, direction, wallDirection, modelItem
							.wallType, wallWidth, this.wallList)
						//计算得出墙体相应的位置和变形属性
						modelItem.wallPositionX = wallPositionX;
						modelItem.wallPositionY = wallPositionY;
						modelItem.wallScaleX = wallScaleX;
						modelItem.wallScaleY = wallScaleY;

						modelItem.wallRotateY = wallRotateY;
						modelItem.wallWidth = wallWidth;


						if (modelItem.wallType == 2) {
							console.log("移动墙体模型-空间信息1", modelItem, this.gltfWalls)

						}
						// 更新数据
						if (isComputeWall || direction == wallDirection) {

							this.gltfWalls.forEach(gltfItem => {
								if (gltfItem.spaceId == spaceObj.spaceId && wallDirection ==
									gltfItem.wallDirection && modelItem.id == gltfItem
									.wallModelData.id) {

									gltfItem.wallModelData = JSON.parse(JSON.stringify(
										modelItem));
									gltfItem.willCurWallType = modelItem.willCurWallType
									console.log("墙体更新", gltfItem.willCurWallType, direction)
									if (gltfItem.wallModelData.wallType != 0) {
										gltfItem.isDidWall = isCreateNewWall;
									}
								}
							})
						}
						if (modelItem.wallType == 2) {
							console.log("移动墙体模型-墙体信息1++++++++", spaceObj.spaceId, direction,
								wallDirection, isComputeWall, modelItem, this.gltfWalls)
						}


						//数据更新到wallList中，确保数据一致性
						this.wallList.forEach(wallItem => {
							const walls = JSON.parse(wallItem.wallJson);
							// console.log("墙体数据2----------", walls, modelItem);
							walls.wallData.forEach(wall => {
								wall.wallModelData.forEach(wallmodel => {
									//从wallList找到这段墙体
									if (wall.wallDirection == wallDirection &&
										wallmodel.id == modelItem.id && walls
										.spaceId == spaceObj.spaceId) {

										if (wallmodel.wallType == 0 && wallmodel
											.isFixedWidth == 'true') {
											wallmodel.wallWidth = modelItem
												.wallWidth;
											console.log("墙体数据31----实体墙------",
												spaceObj.spaceId, modelItem
												.wallWidth, modelItem);
										}

										if (wallmodel.wallType != 0) {
											wallmodel.wallWidth = modelItem
												.wallWidth;
											const curWallType = wallType.find(
												it => it.type == modelItem
												.willCurWallType)
											if (curWallType) {
												wallmodel.wallType = curWallType
													.type;
											}
										}

									}
								})
							})
							wallItem.wallJson = JSON.stringify(walls);
						})
						if (modelItem.wallType == 2) {
							console.log("移动墙体模型-墙体信息2++++++++", spaceObj.spaceId, direction,
								wallDirection, isComputeWall, modelItem, this.wallList)
						}

					})
				} else {
					console.log("同面墙体只移动位置", direction, wallDirection)
					item.wallModelData.forEach((modelItem, index) => { //每个墙壁下的位置计算
						// 默认空间中心点
						let wallPositionX = spaceObj.centerX / 100;
						let wallPositionY = spaceObj.centerY / 100;
						let wallRotateY = 0;

						let wallHeight = 10; //item.wallHeight // 墙体厚度模型10cm
						if (wallDirection == "N") {
							wallPositionY = wallPositionY * -1 - spaceObj.spaceHeight / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionY = wallPositionY + wallHeight2;

						} else if (wallDirection == "S") {
							wallPositionY = wallPositionY * -1 + spaceObj.spaceHeight / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionY = wallPositionY - wallHeight2;
						}
						if (wallDirection == "E") {
							// console.log("模型参数", wallPositionX, spaceObj.spaceWidth)
							wallPositionY = wallPositionY * -1;
							wallPositionX = wallPositionX + spaceObj.spaceWidth / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionX = wallPositionX - wallHeight2; // 减去墙体本身的厚度
							wallRotateY = Math.PI / 2; // 东西墙 模型旋转90度
						} else if (wallDirection == "W") {
							wallPositionY = wallPositionY * -1;
							wallPositionX = wallPositionX - spaceObj.spaceWidth / 2 / scale;
							let wallHeight2 = wallHeight / 2 / scale;
							wallPositionX = wallPositionX + wallHeight2; // 减去墙体本身的厚度
							wallRotateY = Math.PI / 2; // 东西墙 模型旋转90度
						}
						let wallScaleX = modelItem.wallScaleX;
						let wallScaleY = 1;
						let modelWidth = 10;
						if (modelItem.wallType == '7') {
							modelWidth = 150
						} else if (modelItem.wallType == '21') {
							modelWidth = 100
						} else if (modelItem.wallType == '22') {
							modelWidth = 200
						} else if (modelItem.wallType == '23') {
							modelWidth = 300
						} else if (modelItem.wallType == '24') {
							modelWidth = 400
						} else if (modelItem.wallType == '25') {
							modelWidth = 500
						} else if (modelItem.wallType == '26') {
							modelWidth = 600
						}
						let tmdWidth = modelItem.wallWidth; //记录
						// console.log("XXXXXXXXXXXXXXXX", modelWidth, spaceObj)
						let wallWidth = 0; // 墙体宽度
						// 计算墙体的 X Y W H
						//说明该面墙壁只使用了一个模型-独占形式
						if (modelItem.isStepAsideTopRight == 'true' && modelItem
							.isStepAsideBottomLeft == 'true') {
							if (wallDirection == "S" || wallDirection == "N") { //南北
								wallScaleX = spaceObj.spaceWidth / modelWidth;
							} else { //东西
								wallScaleX = spaceObj.spaceHeight / modelWidth;
							}
							if ((parseInt(modelItem.wallType) >= 21 && parseInt(modelItem.wallType) <=
									26) || parseInt(modelItem.wallType) == 7) {} else {
								modelItem.wallWidth = wallScaleX * modelWidth; // 解决模型行拉伸定位问题， 先注释
							}

						} else { //墙面是多端墙体组合而成的
							if (modelItem.isFixedWidth == 'true') { //该墙体锁定宽度-即不可缩放
								wallWidth = modelItem.wallWidth; // 墙体宽度
								// console.log("模型的尺寸",wallWidth, spaceObj.spaceWidth, spaceObj.centerX)
								//起始墙体-南北从左侧算，东西则从上侧计算
								if (modelItem.isStepAsideBottomLeft == 'true' || modelItem
									.isStepAsideTopRight == 'true') {
									if (wallDirection == "S" || wallDirection == "N") { //南北
										wallPositionX = spaceObj.centerX - (spaceObj.spaceWidth -
											wallWidth) / 2;
										wallPositionX = wallPositionX / scale; // 转换成m
									} else {
										wallPositionY = -spaceObj.centerY - (spaceObj.spaceHeight -
											wallWidth) / 2;
										wallPositionY = wallPositionY / scale; // 转换成m
									}
								} else {
									if (wallDirection == "S" || wallDirection == "N") { //南北
										wallPositionX = lastWallPosition + (wallWidth / 2 / scale);
									} else {
										wallPositionY = lastWallPosition + (wallWidth / 2 / scale);
									}
								}
								// console.log("模型的尺寸",wallWidth, wallPositionX)
								if (modelItem.wallType == 0) {
									wallScaleX = modelItem.wallWidth / wallHeight;
								} else {
									console.log("墙体模型的缩放", spaceObj.spaceId, wallDirection, modelItem);
									// if(!moveOut){
									const curWallType = wallType.find(it => it.type == modelItem
										.wallType)
									wallScaleX = modelItem.wallWidth / curWallType.width;

									console.log("墙体模型的缩小", modelItem, direction, wallDirection);
									// }else{
									// 	console.log("墙体模型的放大", wallScaleX);
									// }

								}
								//计算当前墙体占据的整面墙体的大小-方便下一段墙体的计算
								if (wallDirection == "S" || wallDirection == "N") { //南北
									lastWallPosition = wallPositionX + wallWidth / 2 / scale;
								} else {
									lastWallPosition = wallPositionY + wallWidth / 2 / scale;
								}
								// wallPositionY = 1;
							} else { //可变墙体-UE编辑器通常把它放到最后一段墙体
								wallWidth = 0;
								//墙体的宽度是计算得出的
								if (wallDirection == "S" || wallDirection == "N") { //南北
									wallWidth = (spaceObj.centerX + spaceObj.spaceWidth / 2) -
										lastWallPosition * scale; // 墙体宽度
									// console.log("最后一个模型",spaceObj.centerX, spaceObj.spaceWidth / 2, lastWallPosition)
								} else {
									wallWidth = (-spaceObj.centerY + spaceObj.spaceHeight / 2) -
										lastWallPosition * scale; // 墙体宽度
								}
								wallWidth = wallWidth / scale; // cm转换成m
								if (modelItem.wallType == 0) {
									wallScaleX = wallWidth * wallHeight;
									if (wallDirection == "S" || wallDirection == "N") { //南北
										wallPositionX = lastWallPosition + wallWidth / 2;
									} else {
										wallPositionY = lastWallPosition + wallWidth / 2;
									}
								}
								modelItem.wallWidth = wallWidth * scale; //确保单位一致
								// wallPositionY = 1;
							}
						}


						console.log("移动墙体模型-空间信息", spaceObj.spaceWidth, spaceObj.centerX, spaceObj
							.centerY, spaceObj)
						console.log("移动墙体模型-墙体信息", spaceObj.spaceId, direction, wallDirection, modelItem
							.wallType, wallWidth, this.wallList)
						//计算得出墙体相应的位置和变形属性
						modelItem.wallPositionX = wallPositionX;
						modelItem.wallPositionY = wallPositionY;
						modelItem.wallScaleX = wallScaleX;
						modelItem.wallScaleY = wallScaleY;

						modelItem.wallRotateY = wallRotateY;
						modelItem.wallWidth = wallWidth;

						// 更新数据
						if (isComputeWall || direction == wallDirection) {

							this.gltfWalls.forEach(gltfItem => {
								if (gltfItem.spaceId == spaceObj.spaceId && wallDirection ==
									gltfItem.wallDirection && modelItem.id == gltfItem
									.wallModelData.id) {
									if (direction == wallDirection) { // 墙体移动方向和墙面方向一致则执行位置移动
										let tempWallModelData = gltfItem.wallModelData;
										tempWallModelData.wallPositionX = wallPositionX
										tempWallModelData.wallPositionY = wallPositionY
										gltfItem.wallModelData = tempWallModelData;
									} else {
										gltfItem.wallModelData = JSON.parse(JSON.stringify(
											modelItem));
										gltfItem.willCurWallType = modelItem.willCurWallType
									}
									if (gltfItem.wallModelData.wallType != 0) {
										gltfItem.isDidWall = isCreateNewWall;
									}

								}
							})
						}


						//数据更新到wallList中，确保数据一致性
						this.wallList.forEach(wallItem => {
							const walls = JSON.parse(wallItem.wallJson);
							// console.log("墙体数据2----------", walls, modelItem);
							walls.wallData.forEach(wall => {
								wall.wallModelData.forEach(wallmodel => {
									//从wallList找到这段墙体
									if (wall.wallDirection == wallDirection &&
										wallmodel.id == modelItem.id && walls
										.spaceId == spaceObj.spaceId) {

										if (wallmodel.wallType == 0 && wallmodel
											.isFixedWidth == 'true') {
											wallmodel.wallWidth = modelItem
												.wallWidth;
											console.log("墙体数据31----实体墙------",
												spaceObj.spaceId, modelItem
												.wallWidth, modelItem);
										}

										if (wallmodel.wallType != 0) {
											wallmodel.wallWidth = modelItem
												.wallWidth;
											const curWallType = wallType.find(
												it => it.type == modelItem
												.willCurWallType)
											if (curWallType) {
												wallmodel.wallType = curWallType
													.type;
											}
										}

									}
								})
							})
							wallItem.wallJson = JSON.stringify(walls);
						})

					})
				}

			})
			// console.log("墙体数据2", this.gltfWalls, this.wallList);
		},
		//更新墙体模型的位置
		updateAllWallHandle() { //spaceList gltfSpaces
			console.warn("***updateAllWallHandle***")
			this.spaceList.forEach((spaceObj) => {
				// 根据空间，更新前提数据
				let wallObj = this.wallList.find((item) => {
					return item.id == spaceObj.wallId;
				})
				if (wallObj) {
					let element = JSON.parse(wallObj.wallJson);
					// console.warn("****wallObj**",element)
					this.computeWallHandleOld(spaceObj, element); // 重新计算-并把空间的计算结果同步到gltfWalls中
				}
			})
			for (let index = 0; index < this.gltfWalls.length; index++) {
				const element = this.gltfWalls[index];
				this.drawModel(element.wallModelData, null, element, false)
			}
		},
		//加载变化的空间的墙体模型
		loadChangeWallModels(item, resolve) {
			var that = this;
			let wallObj = item;
			console.log("处理模型替换", item);
			if (item.wallModelData.wallWidth == 0) { // 模型隐藏
				return resolve();
			}
			if (item.wallModelData.willCurWallType && item.wallModelData.willCurWallType > 0) {
				const curWallType = wallType.find(it => it.type == item.wallModelData.willCurWallType)
				console.log("加载的模型", item, item.wallModelData.willCurWallType, curWallType);
				if (!curWallType) {
					return resolve();
				}
				that.loader.load(curWallType.url, (gltf) => {

					// 旧的模型
					let spaceInitMatrix = []; //记录下动画创建时的初始变换矩阵
					wallObj.instancedMeshIndexList.forEach(it => {
						let _index = it.instancedMeshIndex;
						let instancedMesh = this.instancedMeshList[_index]; //获取网格实例
						let startMatrix = new THREE.Matrix4(); //定义一个四维矩阵
						instancedMesh.getMatrixAt(it.instancedAtIndex,
						startMatrix); //获取当前几何体的四维矩阵到stratMatrix里面
						spaceInitMatrix.push({
							index: _index,
							matrix: startMatrix.clone(),
						})
					});

					wallObj.instancedMeshIndexList.forEach(it => {
						let _index = it.instancedMeshIndex;
						let instancedMesh = this.instancedMeshList[_index]; //获取网格实例
						let tmp = spaceInitMatrix.find(it => it.index == _index);
						let stratMatrix = tmp.matrix.clone(); //获取初始变换矩阵
						// // 计算变化后的位置：位移后的位置 是 当前几何体的位置参数 加上 模型移动后的位置偏移量


						let scaleMatrix = new THREE.Matrix4(); //定义一个缩放变化矩阵
						let panMatrix = new THREE.Matrix4(); //定义一个平移变化矩阵

						scaleMatrix.makeScale(0, 0, 0); //获得缩放变化矩阵
						panMatrix.makeTranslation(0, 0, 0); //获得平移变化矩阵
						stratMatrix.multiply(scaleMatrix).premultiply(panMatrix); //通过矩阵计算获得最终的形变矩阵
						instancedMesh.instanceMatrix.needsUpdate = true; //更新之前，必须开启开关
						instancedMesh.setMatrixAt(it.instancedAtIndex, stratMatrix); //更新几何体的世界矩阵
					})

					let newWallObj = JSON.parse(JSON.stringify(item))


					const wallType = item.wallModelData.willCurWallType;
					console.log("重新组合新模型数据", newWallObj, item.wallModelData, wallType);

					newWallObj.willCurWallType = -1;

					let wallModelData = newWallObj.wallModelData;
					wallModelData.wallScaleX = 1;
					wallModelData.wallScaleY = 1;
					wallModelData.lastWallType = item.wallModelData.wallType;
					wallModelData.wallType = wallType;
					wallModelData.willCurWallType = -1;
					newWallObj.wallModelData = wallModelData;
					newWallObj.wallScaleX = 1;
					newWallObj.wallScaleY = 1;

					let realWallArr = this.preWallData([newWallObj]);
					const realData = realWallArr[0];

					// 新的模型
					gltf.scene.traverse((child) => {
						if (child.isMesh && child.visible) {
							let instancedMesh = new THREE.InstancedMesh(child.geometry.clone(), child
								.material.clone(), realData.list.length);
							this.instancedMeshList.push(instancedMesh);
							//realData 该模型被重复使用时的每一次的形变参数等
							realData.list && realData.list.forEach((it, i) => {
								gltf.scene.position.set(item.wallPositionX, 0, item
									.wallPositionY);
								gltf.scene.scale.set(1, 1, 1);
								gltf.scene.rotation.y = item.wallRotateY;

								gltf.scene.updateMatrixWorld(); //更新世界坐标-这样，子模型也同步更新了
								instancedMesh.setMatrixAt(i, child.matrixWorld);
								instancedMesh.instanceMatrix.needsUpdate = true;
								// instancedMesh.setColorAt(i, child.material.color);
								// instancedMesh.instanceColor.needsUpdate = true;
								// console.log("***matrixWorld***",child.matrixWorld);
								let gltfWall = that.gltfWalls.find(gltfWall => gltfWall.uniId ==
									it.uniId); //判断是否已经添加过
								if (!gltfWall) {
									let md = {
										uniId: it.uniId, //模型实例的唯一标识
										spaceId: it.spaceId,
										instancedMeshIndexList: [ //标识网格实例数组的序号 以及 当前几何体 在网格实例的序号
											{
												instancedMeshIndex: this
													.instancedMeshList.length - 1,
												instancedAtIndex: i
											},
										],
										// id:child.id,//几何体的id
										// name:child.name,//几何体的id
										wallPositionX: item.wallPositionX,
										wallPositionY: item.wallPositionY,
										wallScaleX: 1,
										wallScaleY: 1,
										wallRotateY: item.wallRotateY,
										wallWidth: item.wallWidth,
										wallModelData: wallModelData,
										wallModelInitData: item, // 保留初始化墙体数据，方便空间变形计算缩放比例 
										wallDirection: it.wallDirection,
										willCurWallType: -1, // 即将成为当前模型，作用于动画加载完替换
										lastWallType: wallModelData.lastWallType // 上一次墙体模型
									};
									that.gltfWalls.push(md);

								} else {
									gltfWall.instancedMeshIndexList.push({
										instancedMeshIndex: this.instancedMeshList
											.length - 1,
										instancedAtIndex: i
									})
								}
							})
							instancedMesh.userType = "mesh";
							that.scene.add(instancedMesh);
						}
					});

					resolve();
				})
			}
			resolve();
		},
		// 空间移动，
		changCurSpaceArea(data) {
			console.log("当前户型的核心点", this.curHouseObj.houseCore, this.overChange);
			const houseCore = this.curHouseObj.houseCore.split(',');
			const coreX = houseCore[0] | 0
			const coreY = houseCore[1] | 0
			// 根据核心点计算空间所在象限
			this.spaces1 = [];
			this.spaces2 = [];
			this.spaces3 = [];
			this.spaces4 = [];
			let curSpace = null;
			for (let index = 0; index < this.spaceList.length; index++) {
				const element = this.spaceList[index];
				if (element.centerX > coreX) { // 2 3象限
					if (element.centerY > coreY) { // 2象限
						console.log(`象限2 ${element}`);
						element.quadrant = 2;
						this.spaces2.push(element)
					} else { // 3象限
						console.log(`象限3 ${element}`);
						element.quadrant = 3;
						this.spaces3.push(element)
					}
				} else { // 1 4象限
					if (element.centerY > coreY) { // 1象限
						console.log(`象限1 ${element}`);
						element.quadrant = 1;
						this.spaces1.push(element)
					} else { // 4象限
						console.log(`象限4 ${element}`);
						element.quadrant = 4;
						this.spaces4.push(element)
					}
				}
				if (element.spaceId == data.spaceId) {
					curSpace = element;
				}
			}

			console.log("当前space所在象限", data.spaceId, curSpace.spaceId, curSpace.quadrant);
			console.log("象限", this.spaces1, this.spaces2, this.spaces3, this.spaces4);


			this.calculateSpaceData(curSpace, data)
		},
		calculateSpaceData(curSpace, data) {
			let that = this;
			this.curSpaceObj = curSpace;

			// 计算宽高移动数值 
			const changeArea = data.area;
			const isZoomIn = data.isZoomIn;
			const oldArea = (curSpace.spaceWidth / 100) * (curSpace.spaceHeight / 100);
			const newArea = oldArea + changeArea * (data.isZoomIn ? 1 : -1);
			const sizeScale = Math.sqrt(newArea / oldArea);

			// 新的宽度
			let newWidth = curSpace.spaceWidth * sizeScale;

			if (newWidth < curSpace.spaceWidthMin) {
				newWidth = curSpace.spaceWidthMin
			}
			if (newWidth > curSpace.spaceWidthMax) {
				newWidth = curSpace.spaceWidthMax
			}
			// 新的高度
			let newHeight = newArea * 10000 / newWidth;

			if (newHeight < curSpace.spaceHeightMin) {
				newHeight = curSpace.spaceHeightMin
			}
			if (newHeight > curSpace.spaceHeightMax) {
				newHeight = curSpace.spaceHeightMax
			}

			newWidth = newArea * 10000 / newHeight;


			let changeWidth = Math.abs(newWidth - curSpace.spaceWidth)
			let changeHeight = Math.abs(newHeight - curSpace.spaceHeight)

			console.log("变化的尺寸", changeWidth, changeHeight, newWidth, newHeight, curSpace.spaceWidth, curSpace
				.spaceHeight);

			if (curSpace.quadrant == 1) {
				// 默认往南 往西移动
				this.moveSpace(curSpace, 1, 3, isZoomIn, newArea, newWidth, newHeight, changeWidth, changeHeight)
			}
			if (curSpace.quadrant == 2) {
				// 默认往南 往西移动
				this.moveSpace(curSpace, 1, 4, isZoomIn, newArea, newWidth, newHeight, changeWidth, changeHeight)
			}
			if (curSpace.quadrant == 3) {
				// 默认往南 往东移动
				this.moveSpace(curSpace, 2, 4, isZoomIn, newArea, newWidth, newHeight, changeWidth, changeHeight)
			}
			if (curSpace.quadrant == 4) {
				// 默认往南 往西移动
				this.moveSpace(curSpace, 2, 3, isZoomIn, newArea, newWidth, newHeight, changeWidth, changeHeight)
			}
			setTimeout(() => {
				// that.updataPageData();
				that.$store.state.overChange = false;
				that.callBackFun && that.callBackFun(true);
				// that.calculateLayoutModelSize(); //重新计算家具位置
				that.updateWallModels(); // 替换墙体模型
				that.changeLayoutModel(); // 变更空间里面的家具模型
			}, 4200);
		},
		currWallLock(direction, curSpace){
			let curDirection = ""
			let faceDirection = ""
			switch (direction) {
		        case 1:
					curDirection = "N";
					faceDirection = "S";
		            break;
		        case 2:
					curDirection = "S";
					faceDirection = "N";
		            break;
		        case 3:
					curDirection = "W";
					faceDirection = "E";
		            break;
		        case 4:
					curDirection = "E";
					faceDirection = "W";
		            break;
		    }
			const wallInfo = this.wallList.find((item)=>{
				let element = JSON.parse(item.wallJson);
				return element.spaceId == curSpace.spaceId;
			})
			let walls = JSON.parse(wallInfo.wallJson).wallData;
		
			const wall = walls.find((item)=>{ // 当前墙面锁定
				return item.wallDirection==curDirection && item.isLocked=="true"
			})
			const faceWall = walls.find((item)=>{ // 对面墙面锁定
				return item.wallDirection==faceDirection && item.isLocked=="true"
			})
			
			if(wall){
				if(faceWall){
					return -1 // 当前对面同时锁定
				}
				return 0 // 当前锁定
			}else{
				return 1 // 不锁定，可以移动
			}
			
		},
		// 排查关联空间是否达到极限值
		checkRightSpace(isZoomIn, changeValue, isNS, curSpace){
			if(changeValue == 0){
				return;
			}
			let n = isZoomIn?1:-1;
			let l = isZoomIn?-1:1;
			let result = true;
			let space = null;
			let newValue = changeValue;
		
			console.log("排查空间",isZoomIn, changeValue,isNS, this.leftSpaces, this.rightSpaces);
			for (let index = 0; index < this.leftSpaces.length; index++) {
				const element = this.leftSpaces[index];
				// 过滤掉花园判断
				if(element.spaceType == 14 || element.spaceId == curSpace.spaceId){
					continue;
				}
				let newWidth = element.spaceWidth + l * changeValue;
				let newHeight = element.spaceHeight + l * changeValue;
				if(isNS){
					if( newHeight > element.spaceHeightMax || newHeight < element.spaceHeightMin){
						result = false;
						space = element;
						break;
					}
				}else{
					if(newWidth > element.spaceWidthMax || newWidth < element.spaceWidthMin){
						result = false;
						space = element;
						break;
					}
				}
			}
		
			for (let index = 0; index < this.rightSpaces.length; index++) {
				const element = this.rightSpaces[index];
				// 过滤掉花园判断
				if(element.spaceType == 14){
					console.log("空间排查跳出")
					continue;
				}
				let newWidth = element.spaceWidth + n * changeValue;
				let newHeight = element.spaceHeight + n * changeValue;
				
				if(isNS){
					if( newHeight > element.spaceHeightMax || newHeight < element.spaceHeightMin){
						result = false;
						space = element;
						const newHeightValue = newHeight > element.spaceHeightMax ? element.spaceHeightMax : element.spaceHeightMin;
						newHeight = newHeightValue - newHeight;
						const newChangeValue = changeValue - newHeight;
						if(newValue > newChangeValue){
							newValue = newChangeValue;
						}
						break;
					}
				}else{
					console.log("排查右边空间",newWidth, element.spaceWidthMax,newWidth, element.spaceWidthMin);
					if(newWidth > element.spaceWidthMax || newWidth < element.spaceWidthMin){
						result = false;
						space = element;
						let newWidthValue = newWidth > element.spaceWidthMax ? element.spaceWidthMax : element.spaceWidthMin
						if(isZoomIn){ // 放大
							if(newWidth>element.spaceWidthMax){ // 关联空间放大时已经是最大，则变化值为0
								newValue = 0
								break;
							}
						}else{
							newWidthValue = newWidth < element.spaceWidthMin ? element.spaceWidthMin : newWidth;
							console.log("排查右边空间2",newWidth, element.spaceWidthMax, element.spaceWidthMin);
						}
						newWidth = newWidthValue - newWidth;
						const newChangeValue = changeValue - newWidth;
						if(newValue > newChangeValue){
							newValue = newChangeValue;
						}
						break;
					}
				}
			}
			
			if(!result){
				this.$message.warning(`关联空间[${ space && space.spaceName || ''}]达到极限值`);
			}
			return {"result":result,"newValue":newValue}
		},
		
		//空间移动
		moveSpace(curSpace, directionIndex, directionIndex01, isZoomIn, newArea, newWidth, newHeight, changeWidth,
			changeHeight) {
			let that = this;

			const wallLock = this.currWallLock(directionIndex, curSpace); //南边
			const wallLock01 = this.currWallLock(directionIndex01, curSpace); //东边

			console.log("移动空间", wallLock, wallLock01)

			if (wallLock == -1 && wallLock01 == -1) {
				return this.$message.warning("空间尺寸已锁定");
			}
			let changeValue = changeHeight;
			if (wallLock == -1) {
				if (wallLock01 == 0) {
					directionIndex01 = directionIndex01 == 4 ? 3 : 4; // 往西移动
				}
				// 南北锁死，重新计算移动的方向
				newWidth = newArea / (curSpace.spaceHeight / 100) * 100
				changeWidth = newWidth / 100 - curSpace.spaceWidth / 100;
				changeWidth = Math.abs(changeWidth * 100);
				directionIndex = directionIndex01; // 往东移动

				changeValue = changeWidth;

				console.log("高度锁死不能拉伸, 宽度变化1", newWidth, directionIndex, curSpace.spaceWidth, curSpace.spaceHeight,
					changeValue);
				that.selectWall(directionIndex);

				let checkResult = this.checkRightSpace(!isZoomIn, changeWidth, false, curSpace)
				if (!checkResult.result) {
					changeWidth = checkResult.newValue
				}
				console.log("宽度达到极限值结果++++++++++++++", checkResult, changeWidth)

				that.moveSpaceWall(that.curWallDirection, isZoomIn, changeWidth);
				// that.autoCreateWall(directionIndex, curSpace)
				return;
			} else {
				if (wallLock == 0) {
					directionIndex = directionIndex == 2 ? 1 : 2; // 往北边移动
				}

				if (wallLock01 == -1) {
					// 东西锁死，重新计算移动方向
					newHeight = newArea / (curSpace.spaceWidth / 100) * 100
					changeHeight = newHeight / 100 - curSpace.spaceHeight / 100;
					changeHeight = Math.abs(changeHeight * 100);
					changeValue = changeHeight;

					that.selectWall(directionIndex);

					let checkResult = this.checkRightSpace(!isZoomIn, changeHeight, true, curSpace)
					console.log("高度达到极限值结果++++++++++++++", checkResult, changeHeight)

					if (!checkResult.result) {
						changeHeight = checkResult.newValue
					}

					that.moveSpaceWall(that.curWallDirection, isZoomIn, changeHeight);
					// 自动补墙逻辑
					// that.autoCreateWall(directionIndex, curSpace);
					return
				}

				if (wallLock01 == 0) {
					directionIndex01 = directionIndex01 == 4 ? 3 : 4; // 往西移动
				}

				console.log("要变化的宽度", newWidth, newHeight)
				// 目标宽度
				if (newHeight > curSpace.spaceHeightMax) {
					newHeight = curSpace.spaceHeightMax;
					changeHeight = Math.abs(newHeight - curSpace.spaceHeight)
					// 重新计算宽度值
					newWidth = (newArea / (newHeight / 100)) * 100
					changeWidth = (newWidth / 100 - curSpace.spaceWidth / 100) * 100;
					console.log("高度达到最大值，重新计算宽度", newWidth, newHeight, changeWidth, changeHeight)
				}

				if (newHeight < curSpace.spaceHeightMin) {
					newHeight = curSpace.spaceHeightMin;
					changeHeight = Math.abs(newHeight - curSpace.spaceHeight)
					// 重新计算宽度值
					newWidth = (newArea / (newHeight / 100)) * 100
					changeWidth = Math.abs((newWidth / 100 - curSpace.spaceWidth / 100) * 100);
					console.log("高度达到最小值，重新计算宽度", newWidth, newHeight, changeWidth, changeHeight)
				}

				if (newWidth > curSpace.spaceWidthMax) {
					newWidth = curSpace.spaceWidthMax;
					changeWidth = Math.abs(newWidth - curSpace.spaceWidth)
					// 重新计算宽度值
					newHeight = (newArea / (newWidth / 100)) * 100
					changeHeight = (newHeight / 100 - curSpace.spaceHeight / 100) * 100;
					console.log("宽度达到最大值，重新计算高度", newWidth, newHeight, changeWidth, changeHeight)
				}

				if (newWidth < curSpace.spaceWidthMin) {
					newWidth = curSpace.spaceWidthMin;
					changeWidth = Math.abs(newWidth - curSpace.spaceWidth)
					// 重新计算宽度值
					newHeight = (newArea / (newWidth / 100)) * 100
					changeHeight = Math.abs((newHeight / 100 - curSpace.spaceHeight / 100) * 100);
					console.log("宽度达到最小值，重新计算高度", newWidth, newHeight, changeWidth, changeHeight)
				}

				if (changeHeight > 0) {

					that.changeSpaces = [];

					that.selectWall(directionIndex);

					let checkResult = this.checkRightSpace(!isZoomIn, changeHeight, true, curSpace)
					console.log("高度达到极限值结果++++++++++++++", checkResult, changeHeight)

					if (!checkResult.result) {
						changeHeight = checkResult.newValue
					}

					that.moveSpaceWall(that.curWallDirection, isZoomIn, changeHeight);
					// 自动补墙逻辑
					// that.autoCreateWall(directionIndex, curSpace)
				}

				let timeout = 0
				if (changeWidth > 0 && changeHeight > 0) {
					timeout = 2100
				}

				console.log("改变尺寸", changeWidth, changeHeight, newWidth, newHeight, timeout, directionIndex,
					directionIndex01, wallLock, wallLock01)

				if (changeWidth > 0) {
					setTimeout(() => {

						that.changeSpaces = [];
						// // 选中墙面
						that.selectWall(directionIndex01);
						// 计算
						let checkResult = this.checkRightSpace(!isZoomIn, changeWidth, false, curSpace)
						if (!checkResult.result) {
							changeWidth = checkResult.newValue
						}
						console.log("宽度达到极限值结果++++++++++++++", checkResult, changeWidth)
						// 移动墙面
						that.moveSpaceWall(that.curWallDirection, isZoomIn, changeWidth);
						// 自动补墙逻辑
						// that.autoCreateWall(directionIndex01, curSpace)
					}, timeout);
				}
			}
		},
		//移动空间的墙体
		moveSpaceWall(direction, moveOut, moveValue) {
			// let isNS = (direction == "N" || direction == "S")
			// if(!this.checkRightSpace(!moveOut, moveValue, isNS)){
			// 	return
			// }
			// 隐藏变化空间的家具模型，空间动画结束后显示
			if (moveValue <= 0) { // 无需变化
				return
			}
			this.changeLayoutModelState(); //隐藏这个空间的家具模型
			console.log("关联空间XXXXX", this.leftSpaces, this.rightSpaces)
			for (let index = 0; index < this.leftSpaces.length; index++) {
				const element = this.leftSpaces[index];
				const space = this.spaceList.find((item) => {
					return item.spaceId == element.spaceId;
				})
				this.moveWall(space, direction, moveOut, moveValue);
				// this.wallTransform(space, direction, moveOut, moveValue);
			}
			let otherdirection = "";
			switch (direction) {
				case "E":
					otherdirection = "W"
					break;
				case "W":
					otherdirection = "E"
					break;
				case "N":
					otherdirection = "S"
					break;
				case "S":
					otherdirection = "N"
					break;
			}
			for (let index = 0; index < this.rightSpaces.length; index++) {
				const element = this.rightSpaces[index];
				this.moveWall(element, otherdirection, !moveOut, moveValue);
			}
			console.log(
				`当前空间的后id：${this.curSpaceObj.spaceId};墙面方向：${direction};宽度：${this.curSpaceObj.spaceWidth};高度：${this.curSpaceObj.spaceHeight}`
				)
		},
		// 调整大小
		// direction:方向
		// moveOut:是否外移
		// moveValue: 移动距离
		moveWall(spaceObj, direction, moveOut, moveValue) {
			console.log(`移动的空间的id-------：${spaceObj.spaceId};移动方向：${direction};是否外移：${moveOut};移动距离：${moveValue}`)
			const oldSpaceObj = JSON.parse(JSON.stringify(spaceObj))

			const cube = this.gltfSpaces.find((item) => {
				return item.spaceId == spaceObj.spaceId;
			})

			if (!cube) {
				return
			}

			if (!moveOut) {
				moveValue = moveValue * -1;
			}
			const {
				position,
				scale
			} = cube;
			// 重新计算缩放 和 位置
			let toScaleX = scale.x;
			let toScaleZ = scale.z;
			let toPx = position.x;
			let toPz = position.z;
			if (direction == 'E' || direction == 'W') {
				let spaceWidth = scale.x * 300;
				toScaleX = (spaceWidth + moveValue) / 300;
				if (direction == 'W') {
					toPx = position.x - moveValue / 2 / 100;
				} else {
					toPx = position.x + moveValue / 2 / 100;
				}
				spaceObj.spaceWidth += moveValue;
				spaceObj.centerX = toPx * 100;
			}

			if (direction == 'N' || direction == 'S') {
				let spaceHeight = scale.z * 300;
				toScaleZ = (spaceHeight + moveValue) / 300;
				if (direction == 'N') {
					toPz = position.z - moveValue / 2 / 100;
				} else {
					toPz = position.z + moveValue / 2 / 100;
				}
				spaceObj.spaceHeight += moveValue;
				spaceObj.centerY = toPz * 100 * -1;
			}
			console.log("curSpaceObj", this.curSpaceObj.spaceId, spaceObj.spaceId, spaceObj.centerX, spaceObj.centerY,
				toScaleX, toScaleZ, toPx, toPz)
			console.log("当前空间变化后的尺寸", spaceObj.spaceWidth, spaceObj.spaceHeight, spaceObj.spaceId)

			// 更新数据
			const spaceIndex = this.spaceList.findIndex((item) => {
				return item.spaceId == spaceObj.spaceId;
			})
			if (spaceIndex != -1) {
				this.spaceList[spaceIndex] = spaceObj;
				if (this.curSpaceObj.spaceId == spaceObj.spaceId) {
					this.curSpaceObj = spaceObj;
				}
			}
			this.curHouseObj.houseJson = JSON.stringify(this.spaceList);
			//空间动画处理-提取到floorMethod.js中
			this.changeSpacesAnim({
				spaceId: spaceObj.spaceId,
				toScaleX,
				toScaleZ,
				toPx,
				toPz,
				spaceObj
			})
			// 墙体动画处理
			//// 根据空间尺寸，更新前提数据
			const wallObj = this.wallList.find((item) => {
				return item.id == spaceObj.wallId;
			})

			const initSpaceObj = this.spaceListBackup.find((item) => {
				return item.spaceId == spaceObj.spaceId;
			})

			if (wallObj) {
				let element = JSON.parse(wallObj.wallJson);
				console.warn("****wallObj**", element)
				this.computeWallHandle(initSpaceObj, spaceObj, element, moveOut,
				direction); // 重新计算-并把空间的计算结果同步到gltfWalls中
			}

			// 移动墙体
			let curSpaceWall = [];
			for (let index = 0; index < this.gltfWalls.length; index++) {
				const element = this.gltfWalls[index];
				if (spaceObj.spaceId == element.spaceId) {
					curSpaceWall.push(element);
				}
			}

			//移动的是西方的墙壁 和 南方的墙壁，该空间的几何体中心则移动变化
			if (direction == 'W' || direction == 'S') {
				spaceObj.rightCenter = true;
			}
			//移动的是东方的墙壁 和 北方的墙壁，该空间的几何体中心则不移动变化
			if (direction == 'E' || direction == 'N') {
				spaceObj.rightCenter = false;
			}
			spaceObj.direction = direction
			// 排序墙体数据
			curSpaceWall.sort(function(a, b) {
				return a.wallModelData.id - b.wallModelData.id
			});
			curSpaceWall.sort(function(a, b) {
				return a.wallDirection.localeCompare(b.wallDirection)
			})

			console.log("移动的墙体：", spaceObj, direction, curSpaceWall);
			// return;
			for (let index = 0; index < curSpaceWall.length; index++) {
				const element = curSpaceWall[index];
				console.log("重新计算墙体-墙体数据：", element, element);
				this.drawModel(element.wallModelData, spaceObj, element, true)
			}
			// }
		},

		/**
		 * 选中墙体触发
		 */
		selectWall(wallIndex) {
			console.log("index", wallIndex)
			switch (wallIndex) {
				case 1:
					this.curWallDirection = "N";
					break;
				case 2:
					this.curWallDirection = "S";
					break;
				case 3:
					this.curWallDirection = "W";
					break;
				case 4:
					this.curWallDirection = "E";
					break;
			}
			this.selectedWall(this.curWallDirection)

			// this.curWallArr = [];
			if (wallIndex != 0) {
				const wallMoveValues = this.curSpaceObj.wallMoveValue;
				console.log
				const values = JSON.parse(wallMoveValues);
				if (this.curWallValue == 150) {
					this.curWallValue = values[wallIndex - 1]
				} else {
					let wallIndex = 0
					switch (this.curWallDirection) {
						case "N":
							wallIndex = 0;
							values[wallIndex] = this.curWallValue;
							values[1] = this.curWallValue;
							break;
						case "S":
							wallIndex = 1;
							values[wallIndex] = this.curWallValue;
							values[0] = this.curWallValue;
							break;
						case "W":
							wallIndex = 2;
							values[wallIndex] = this.curWallValue;
							values[3] = this.curWallValue;
							break;
						case "E":
							wallIndex = 3;
							values[wallIndex] = this.curWallValue;
							values[2] = this.curWallValue;
							break;
					}
				}
				this.curSpaceObj.wallMoveValue = JSON.stringify(values)
				console.log("墙体可移动数据：", this.curSpaceObj.wallMoveValue, this.spaceList);

				const wallStatus = this.curSpaceObj.wallStatus || "[false,false,false,false]"
				const status = JSON.parse(wallStatus);
				// this.curWallHidden = status[wallIndex-1];
				console.log("当前墙面数据：", wallStatus, status, wallIndex);

				const curSpaceGltfWall = this.gltfWalls.filter((item) => {
					return this.curSpaceObj.spaceId == item.spaceId && item.wallDirection == this
						.curWallDirection
				})
				if (curSpaceGltfWall.length != 0) {
					// this.curWallArr.push(...curSpaceGltfWall);
				} else {
					let rightWallD = "";
					switch (wallIndex - 1) {
						case 0:
							rightWallD = "S";
							break;
						case 1:
							rightWallD = "N";
							break;
						case 2:
							rightWallD = "E";
							break;
						case 3:
							rightWallD = "W";
							break;
					}
					for (let index = 0; index < this.leftSpaces.length; index++) {
						const element = this.leftSpaces[index];
						const gltfWall = this.gltfWalls.filter((item) => {
							return element.spaceId == item.spaceId && item.wallDirection == this
								.curWallDirection
						})
					}

					for (let index = 0; index < this.rightSpaces.length; index++) {
						const element = this.rightSpaces[index];
						const gltfWall = this.gltfWalls.filter((item) => {
							return element.spaceId == item.spaceId && item.wallDirection == rightWallD;
						})
					}
				}
			}
		},
		// 选择墙体
		selectedWall(direction) {
			if (!direction || direction == "") {
				return
			}
			console.log(
				`当前空间的id：${this.curSpaceObj.spaceId};墙面方向：${direction};宽度：${this.curSpaceObj.spaceWidth};宽度：${this.curSpaceObj.spaceHeight}`
				)
			console.log("当前空间的:", this.curSpaceObj);
			this.leftSpaces = [];
			this.rightSpaces = [];
			this.tempSpaceList = JSON.parse(JSON.stringify(this.spaceList));
			// 计算关联空间
			this.findLeftRelateSpace(this.curSpaceObj, direction);
			console.log("空间数组:", this.leftSpaces, this.rightSpaces);

			// 计算墙体的可移动范围
			var min = 0;
			var max = 300;
			// 计算最小值
			for (let index = 0; index < this.leftSpaces.length; index++) {
				const element = this.leftSpaces[index];
				console.log("左边空间数据:", element);
				var spaceMoveNW = element.spaceWidth;
				var spaceMoveSW = element.spaceWidth;
				var spaceMoveEH = element.spaceHeight;
				var spaceMoveWH = element.spaceHeight;
				var curSpaceWall = [];
				for (let index = 0; index < this.gltfWalls.length; index++) {
					const wall = this.gltfWalls[index];
					if (element.spaceId == wall.spaceId && wall.wallDirection != direction) {
						curSpaceWall.push(wall);
						if ((direction == "W" || direction == "E") && wall.wallDirection != direction) {
							if (wall.wallDirection == "N") {
								spaceMoveNW -= wall.wallModelData.wallWidth;
								console.log("北边墙:", spaceMoveNW, wall.wallModelData.wallWidth, wall.id);
							}
							if (wall.wallDirection == "S") {
								spaceMoveSW -= wall.wallModelData.wallWidth;
								console.log("南边墙:", spaceMoveSW, wall.wallModelData.wallWidth, wall.id);
							}

							this.curWallValue = Math.floor(Math.min(Math.min(spaceMoveNW, spaceMoveSW), this
								.curWallValue));
						}
						if ((direction == "N" || direction == "S") && wall.wallDirection != direction) {
							if (wall.wallDirection == "E") {
								spaceMoveEH -= wall.wallModelData.wallWidth;
								console.log("东边墙:", spaceMoveNW, wall.wallModelData.wallWidth, wall.id);
							}
							if (wall.wallDirection == "W") {
								spaceMoveWH -= wall.wallModelData.wallWidth;
								console.log("西边墙:", spaceMoveSW, wall.wallModelData.wallWidth, wall.id);
							}
							this.curWallValue = Math.floor(Math.min(Math.min(spaceMoveEH, spaceMoveWH), this
								.curWallValue));
						}
					}
				}

				// 排序墙体数据
				curSpaceWall.sort(function(a, b) {
					return a.wallModelData.id - b.wallModelData.id
				});
				curSpaceWall.sort(function(a, b) {
					return a.wallDirection.localeCompare(b.wallDirection)
				})

				console.log("墙体模型:", curSpaceWall, spaceMoveNW, spaceMoveSW);
				console.log("可缩小的最小值:", Math.floor(Math.min(spaceMoveNW, spaceMoveSW)));

				if ((direction == "W" || direction == "E") && element.spaceWidth == this.curWallValue) {
					this.curWallValue = 149;
				}
				if ((direction == "N" || direction == "S") && element.spaceHeight == this.curWallValue) {
					this.curWallValue = 149;
				}
				// this.curWallValue = Math.floor(Math.min(spaceMoveNW, spaceMoveSW));
			}

			// 计算最大值

			for (let index = 0; index < this.rightSpaces.length; index++) {
				const element = this.rightSpaces[index];
				console.log("右边空间数据:", element);
				var spaceMoveNW = element.spaceWidth;
				var spaceMoveSW = element.spaceWidth;
				var spaceMoveEH = element.spaceHeight;
				var spaceMoveWH = element.spaceHeight;
				var curSpaceWall = [];
				for (let index = 0; index < this.gltfWalls.length; index++) {
					const wall = this.gltfWalls[index];
					if (element.spaceId == wall.spaceId && wall.wallDirection != direction) {
						curSpaceWall.push(wall);
						if ((direction == "W" || direction == "E") && wall.wallDirection != direction) {
							if (wall.wallDirection == "N") {
								spaceMoveNW -= wall.wallModelData.wallWidth;
								console.log("北边墙:", spaceMoveNW, wall.wallModelData.wallWidth, wall.id);
							}
							if (wall.wallDirection == "S") {
								spaceMoveSW -= wall.wallModelData.wallWidth;
								console.log("南边墙:", spaceMoveSW, wall.wallModelData.wallWidth, wall.id);
							}

							this.curWallMaxValue = Math.floor(Math.min(spaceMoveNW, spaceMoveSW)) + this.curWallValue;
						}
						if ((direction == "N" || direction == "S") && wall.wallDirection != direction) {
							if (wall.wallDirection == "E") {
								spaceMoveEH -= wall.wallModelData.wallWidth;
								console.log("东边墙:", spaceMoveNW, wall.wallModelData.wallWidth, wall.id);
							}
							if (wall.wallDirection == "W") {
								spaceMoveWH -= wall.wallModelData.wallWidth;
								console.log("西边墙:", spaceMoveSW, wall.wallModelData.wallWidth, wall.id);
							}
							this.curWallMaxValue = Math.floor(Math.min(spaceMoveEH, spaceMoveWH)) + this.curWallValue;
						}
					}
				}

				// 排序墙体数据
				curSpaceWall.sort(function(a, b) {
					return a.wallModelData.id - b.wallModelData.id
				});
				curSpaceWall.sort(function(a, b) {
					return a.wallDirection.localeCompare(b.wallDirection)
				})

				console.log("墙体模型:", curSpaceWall, spaceMoveNW, spaceMoveSW);
				console.log("可缩小的最小值:", Math.floor(Math.min(spaceMoveNW, spaceMoveSW)));
			}


			console.log(`当前墙面的最大值：${this.curWallMaxValue}, 最小值：${this.curWallValue}`)
			// 统计变化的空间
			this.changeSpaces.push(...this.leftSpaces)
			this.changeSpaces.push(...this.rightSpaces)
		},
		// 递归寻找左边->右边关联空间
		findLeftRelateSpace(spaceObj, direction) {
			const {
				eastId,
				westId,
				northId,
				southId,
				spaceId
			} = spaceObj;

			const leftIndex = this.tempSpaceList.findIndex((item) => {
				return item.spaceId == spaceId;
			})
			if (leftIndex != -1) {
				const spaceObj = this.tempSpaceList[leftIndex];
				this.leftSpaces.push(spaceObj);
				this.tempSpaceList.splice(leftIndex, 1);

				const leftNextIndex = this.tempSpaceList.findIndex((item) => {
					if (direction == "E") {
						return item.spaceId == eastId;
					} else if (direction == "W") {
						return item.spaceId == westId;
					} else if (direction == "S") {
						return item.spaceId == southId;
					} else if (direction == "N") {
						return item.spaceId == northId;
					}
				})
				if (leftNextIndex != -1) {
					const nextSpaceObj = this.tempSpaceList[leftNextIndex];
					console.log("递归再一次", nextSpaceObj);
					this.findRightRelateSpace(nextSpaceObj, direction);
				}

				const rightArr = this.tempSpaceList.filter((item) => {
					if (direction == "E") {
						return item.westId == spaceId;
					} else if (direction == "W") {
						return item.eastId == spaceId;
					} else if (direction == "S") {
						return item.northId == spaceId;
					} else if (direction == "N") {
						return item.southId == spaceId;
					}
				})

				for (let index = 0; index < rightArr.length; index++) {
					const nextSpaceObj = rightArr[index];
					// const nextSpaceObj =  this.tempSpaceList[rightNextIndex];
					console.log("递归再一次", nextSpaceObj);
					this.findRightRelateSpace(nextSpaceObj, direction);
				}

			}

		},
		// 递归寻找右边->左边关联空间
		findRightRelateSpace(spaceObj, direction) {
			const {
				eastId,
				westId,
				northId,
				southId,
				spaceId
			} = spaceObj;

			const rightIndex = this.tempSpaceList.findIndex((item) => {
				return item.spaceId == spaceId;
			})

			if (rightIndex != -1) {
				const spaceObj = this.tempSpaceList[rightIndex];
				this.rightSpaces.push(spaceObj);
				this.tempSpaceList.splice(rightIndex, 1);
				console.log("当前空间数组:", this.tempSpaceList);

				const leftNextIndex = this.tempSpaceList.findIndex((item) => {
					if (direction == "E") {
						return item.spaceId == westId;
					} else if (direction == "W") {
						return item.spaceId == eastId;
					} else if (direction == "N") {
						return item.spaceId == southId;
					} else if (direction == "S") {
						return item.spaceId == northId;
					}
				})
				if (leftNextIndex != -1) {
					const nextSpaceObj = this.tempSpaceList[leftNextIndex];
					console.log("递归再一次", nextSpaceObj);
					this.findLeftRelateSpace(nextSpaceObj, direction);
				}

				const rightArr = this.tempSpaceList.filter((item) => {
					if (direction == "E") {
						return item.eastId == spaceId;
					} else if (direction == "W") {
						return item.westId == spaceId;
					} else if (direction == "N") {
						return item.northId == spaceId;
					} else if (direction == "S") {
						return item.southId == spaceId;
					}
				});

				for (let index = 0; index < rightArr.length; index++) {
					const nextSpaceObj = rightArr[index];
					console.log("递归再一次", nextSpaceObj);
					this.findLeftRelateSpace(nextSpaceObj, direction);
				}

			}
		},

		updateWallModels() {
			let that = this;
			console.log("开始替换墙体模型", this.leftSpaces, this.rightSpaces, this.gltfWalls);
			let promise_list = [];

			// const gltfWalls = JSON.parse(JSON.stringify(this.gltfWalls))
			this.gltfWalls.forEach((item, index) => {
				promise_list.push(
					new Promise((resolve, reject) => {
						this.loadChangeWallModels(item, resolve);
					})
				)
			});

			Promise.all(promise_list).then(() => {
				this.$nextTick(() => {
					let newArr = [];
					const newWalls = that.gltfWalls.filter(it => {
						return !it.isDidWall
					})
					that.gltfWalls = newWalls;
					console.log("加载完成2", newWalls, newArr, that.gltfWalls, that.wallList);
				})
			})
		},
		// 空隙自动补墙逻辑
		autoCreateWall(directionIndex, spaceObj) {
			let direction = ""
			switch (directionIndex) {
				case 1:
					direction = "N"
					break;
				case 2:
					direction = "S"
					break;
				case 3:
					direction = "W"
					break;
				case 4:
					direction = "E"
					break;
				default:
					break;
			}

			// 东西墙 检查 南北墙关联空间  南北墙 检查 东西墙关联空间
			if (direction == "E" || direction == "W") {
				if (spaceObj.quadrant == 3 || spaceObj.quadrant == 4) { // 南边空间
					console.log("南北朝向墙自动补齐", this.leftSpaces, this.rightSpaces)
					this.selectedWall("N");
					this.checkIsAutoCreateWall("N", spaceObj)
					this.selectedWall("S");
					this.checkIsAutoCreateWall("S", spaceObj)
					let autoWall = this.gltfAutoWalls.find(item => {
						return item.spaceId == spaceObj.spaceId;
					})
					if (autoWall) {
						console.log("南北朝向墙自动补齐---", autoWall, this.gltfAutoWalls)
						if (autoWall.wallDirection == "E") {
							autoWall.obj.position.x = (spaceObj.centerX + (spaceObj.spaceWidth / 2) - 5) / 100
						}
					}

				} else { // 北边关联空间

				}
			} else {
				if (spaceObj.quadrant == 3 || spaceObj.quadrant == 4) { // 南边空间
					console.log("东西朝向墙自动补齐", this.leftSpaces, this.rightSpaces)
					this.selectedWall("E");
					this.checkIsAutoCreateWall("E", spaceObj)
					this.selectedWall("W");
					this.checkIsAutoCreateWall("W", spaceObj)
				} else { // 北边关联空间
				}
			}
		},
		// 检测是否需要补强
		checkIsAutoCreateWall(direction, spaceObj) {
			var that = this;
			// 判断南边墙是否需要补充
			if (this.rightSpaces.length == 0) {
				console.log("不需要补墙1", direction, this.gltfAutoWalls)
				return;
			}
			const n = (direction == "S" || direction == "E") ? 1 : -1; // 南北方向计算系数

			console.log("自动补墙", this.leftSpaces, this.rightSpaces);

			let px = 0;
			let pz = 0;
			let sx = 1;
			let sz = 1;
			let rightids = []
			if (spaceObj.quadrant == 3) {

				// 左边空间的最大值
				let leftMaxValue = 0;
				for (let index = 0; index < this.leftSpaces.length; index++) {
					const element = this.leftSpaces[index];
					if (direction == "S" || direction == "N") {
						const curvalue = element.centerX + element.spaceWidth / 2
						if (leftMaxValue < curvalue) {
							leftMaxValue = curvalue
						}
					} else {
						leftMaxValue += (-element.centerY + element.spaceHeight / 2)
					}
				}
				// rightSpaces右边最大值
				let rightMaxValue = 0;
				for (let index = 0; index < this.rightSpaces.length; index++) {
					const element = this.rightSpaces[index];
					if (direction == "S" || direction == "N") {
						const curvalue = element.centerX + element.spaceWidth / 2
						if (rightMaxValue < curvalue) {
							rightMaxValue = curvalue
						}
					} else {
						rightMaxValue += -element.centerY + element.spaceHeight / 2
					}
					rightids.push(element.spaceId)
				}

				// 是否有墙
				const index = this.gltfWalls.findIndex(item => {
					// console.log("墙面模型", item)
					return spaceObj.spaceId == item.spaceId && item.wallDirection == direction;
				})

				// 有墙，左边墙>右边墙，计算南北墙
				if (index != -1 && leftMaxValue > rightMaxValue && (direction == "S" || direction == "N")) {
					console.log("不需要补墙251", index, leftMaxValue, rightMaxValue)
					// 是否补过墙
					const autoWall = this.gltfAutoWalls.find(item => {
						return item.rightids.indexOf(spaceObj.spaceId) != -1 && item.wallDirection == (
							direction == "S" ? "N" : "S");
					})
					if (autoWall) {
						let cube = autoWall.obj;
						if (cube) {
							cube.scale.set(0, 0, 0);
						}
					}
					return
				}
				// 有墙，左边墙>右边墙，计算东西墙
				if (index != -1 && leftMaxValue > rightMaxValue && (direction == "E" || direction == "W")) {
					console.log("不需要补墙252", index, leftMaxValue, rightMaxValue, spaceObj.spaceId, direction, this
						.gltfAutoWalls)
					const autoWall = this.gltfAutoWalls.find(item => {
						return item.rightids.indexOf(spaceObj.spaceId) != -1 && item.wallDirection == (
							direction == "E" ? "W" : "E");
					})
					if (autoWall) {
						let cube = autoWall.obj;
						if (cube) {
							cube.scale.set(0, 0, 0);
						}
					}
					return
				}

				let wallOffset = index != -1 ? -5 : 5;

				console.log("空间最大值", leftMaxValue, rightMaxValue, direction, index);
				const cubeW = Math.abs(leftMaxValue - rightMaxValue);

				if (direction == "S" || direction == "N") {
					px = (Math.min(leftMaxValue, rightMaxValue) + cubeW / 2) / 100
					pz = (-spaceObj.centerY + spaceObj.spaceHeight * n / 2 + wallOffset * n) / 100;
					sx = cubeW / 10;
					// 长边有墙
				} else {
					px = (spaceObj.centerX + spaceObj.spaceWidth * n / 2 + wallOffset * n) / 100;
					pz = (Math.max(leftMaxValue, rightMaxValue) - cubeW / 2) / 100
					sz = cubeW / 10;
				}




			} else {
				let leftMinValue = 0;
				for (let index = 0; index < this.leftSpaces.length; index++) {
					const element = this.leftSpaces[index];
					if (direction == "S" || direction == "N") {
						leftMinValue += (element.centerX - element.spaceWidth / 2)
					} else {
						leftMinValue += (-element.centerY + element.spaceHeight / 2)
					}
				}
				// rightSpaces右边最大值
				let rightMinValue = 0;
				for (let index = 0; index < this.rightSpaces.length; index++) {
					const element = this.rightSpaces[index];
					if (direction == "S" || direction == "N") {
						rightMinValue += (element.centerX - element.spaceWidth / 2)
					} else {
						rightMinValue = (-element.centerY + element.spaceHeight / 2)
					}
					rightids.push(element.spaceId)
				}


				const index = this.gltfWalls.findIndex(item => {
					// console.log("墙面模型", item)
					return spaceObj.spaceId == item.spaceId && item.wallDirection == direction;
				})

				if (index != -1 && leftMinValue < rightMinValue && (direction == "S" || direction == "N")) {
					console.log("不需要补墙251")
					return
				}

				if (index != -1 && leftMinValue > rightMinValue && (direction == "E" || direction == "W")) {
					console.log("不需要补墙252")
					return
				}

				let wallOffset = index != -1 ? -5 : 5;

				console.log("空间最大值", leftMinValue, rightMinValue);
				const cubeW = Math.abs(leftMinValue - rightMinValue);

				if (leftMinValue > rightMinValue && index == -1 && (direction == "S" || direction == "N")) {
					console.log("不需要补墙241", leftMinValue, rightMinValue)

					const autoWall = this.gltfAutoWalls.find(item => {
						return item.rightids.indexOf(spaceObj.spaceId) != -1 && item.wallDirection == (
							direction == "S" ? "N" : "S");
					})
					if (autoWall) {
						let cube = autoWall.obj;
						if (cube) {
							cube.scale.set(0, 0, 0);
						}
					}
					return
				}
				if (leftMinValue < rightMinValue && index == -1 && (direction == "E" || direction == "W")) {
					console.log("不需要补墙242", leftMinValue, rightMinValue)

					const autoWall = this.gltfAutoWalls.find(item => {
						return item.rightids.indexOf(spaceObj.spaceId) != -1 && item.wallDirection == (
							direction == "W" ? "E" : "W");
					})
					if (autoWall) {
						let cube = autoWall.obj;
						if (cube) {
							cube.scale.set(0, 0, 0);
						}
					}
					return
				}
				if (direction == "S" || direction == "N") {
					px = (Math.max(leftMinValue, rightMinValue) - cubeW / 2) / 100
					pz = (-spaceObj.centerY + spaceObj.spaceHeight * n / 2 + wallOffset * n) / 100;
					sx = cubeW / 10;
				} else {
					px = (spaceObj.centerX + spaceObj.spaceWidth * n / 2 + wallOffset * n) / 100;
					pz = (Math.max(leftMinValue, rightMinValue) - cubeW / 2) / 100
					sz = cubeW / 10;
				}
			}

			console.log("空间最大值", px, pz, sx, sz, this.gltfAutoWalls);

			// 寻找是否已添加过墙面
			const autoWall = this.gltfAutoWalls.find(item => {
				return (item.spaceId == spaceObj.spaceId && item.wallDirection == direction) ||
					(item.rightids.findIndex(it => {
						return it == spaceObj.spaceId
					}) != -1 && item.wallDirection == direction == "S" ? "N" : "S") ||
					(item.rightids.findIndex(it => {
						return it == spaceObj.spaceId
					}) != -1 && item.wallDirection == direction == "E" ? "W" : "E")
			})

			if (this.curWallDirection == "S") {
				if (spaceObj.southId > 0) {
					return
				}
			}
			if (this.curWallDirection == "E") {
				if (spaceObj.eastId > 0) {
					return
				}
			}
			if (this.curWallDirection == "N") {
				if (spaceObj.northId > 0) {
					return
				}
			}

			if (this.curWallDirection == "W") {
				if (spaceObj.westId > 0) {
					return
				}
			}

			if (autoWall) {
				console.log("修改补墙的信息", px, pz, sx, sz);
				let cube = autoWall.obj;
				cube.position.set(px, 0, pz);
				cube.scale.set(sx, 1, sz);
			} else {
				console.log("添加补墙的信息", px, pz, sx, sz);

				that.loader.load(wallType[0].url, (gltf) => {
					let cube = gltf.scene;

					cube.position.set(px, 0, pz);
					cube.scale.set(sx, 1, sz);
					that.scene.add(cube);
					let md = {
						obj: cube,
						wallDirection: direction,
						spaceId: spaceObj.spaceId,
						quadrant: spaceObj.quadrant,
						rightids: rightids
					};
					that.gltfAutoWalls.push(md);
					// console.log("模型加载成功", that.gltfAutoWalls, spaceObj.spaceId);
				});
			}
		},
	}
}